//+------------------------------------------------------------------+
//|                                                      BBMacd.mq4  |
//|                                                BBMacd by Mladen  |
//|                                 mrtools added arrows and alerts  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Red
#property indicator_color2     Blue
#property indicator_color3     Lime
#property indicator_color4     Magenta
#property indicator_color5     Magenta
#property indicator_width3     1
#property indicator_width4     1
#property indicator_width5     1
#property indicator_level1     0
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame                   = "current time frame";
extern int    FastLen                     = 12;
extern double FastT3Hot                   = 1.0;
extern int    FastT3Price                 = PRICE_CLOSE;
extern bool   FastT3Original              = false;
extern int    SlowLen                     = 26;
extern double SlowT3Hot                   = 1.0;
extern int    SlowT3Price                 = PRICE_CLOSE;
extern bool   SlowT3Original              = false;
extern int    Length                      = 10;
extern double StDv                        = 1.0;  
extern bool   DoubleMacd                  = true;
extern bool   Interpolate                 = true;  
extern bool   drawDots                    = true;

extern bool   alertsOn                    = true;
extern bool   alertsOnSlope               = true;
extern bool   alertsOnBandBreakout        = true;
extern bool   alertsOnCurrent             = true;
extern bool   alertsMessage               = true;
extern bool   alertsSound                 = false;
extern bool   alertsNotify                = false;
extern bool   alertsEmail                 = false;

extern bool   arrowsVisible               = true;
extern string arrowsIdentifier            = "bbmacd Arrows1";
extern double arrowsDisplacement          = 1.0;

extern bool   arrowsOnSlope               = false;
extern color  arrowsOnSlopeUpColor        = LimeGreen;
extern color  arrowsOnSlopeDnColor        = Red;
extern int    arrowsOnSlopeUpCode         = 241;
extern int    arrowsOnSlopeDnCode         = 242;
extern int    arrowsOnSlopeUpSize         = 1;
extern int    arrowsOnSlopeDnSize         = 1;

extern bool   arrowsOnBandBreakout        = true;
extern color  arrowsOnBandBreakoutUpColor = LimeGreen;
extern color  arrowsOnBandBreakoutDnColor = Red;
extern int    arrowsOnBandBreakoutUpCode  = 119;
extern int    arrowsOnBandBreakoutDnCode  = 119;
extern int    arrowsOnBandBreakoutUpSize  = 3;
extern int    arrowsOnBandBreakoutDnSize  = 3;

extern int    xDistance                   = 10;
extern int    yDistance                   = 10;
extern color  LabelsColorUp               = Green;
extern color  LabelsColorNeutral          = DimGray;
extern color  LabelsColorDown             = Crimson;    


//
//
//
//
//

double buffer1[];
double buffer2[];
double bbMacd[];
double buffer4[];
double buffer5[];
double buffer6[];
double slope[];
double trend[];

//
//
//
//
//

int    timeFrame;
string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,bbMacd);                               
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   
      if (drawDots) 
      {
         SetIndexStyle(2, DRAW_ARROW,0); SetIndexArrow(2, 159);
         SetIndexStyle(3, DRAW_ARROW,0); SetIndexArrow(3, 159);
         SetIndexStyle(4, DRAW_NONE);
      }
      else
      {
         SetIndexStyle(2, DRAW_LINE);
         SetIndexStyle(3, DRAW_LINE);
         SetIndexStyle(4, DRAW_LINE);
      }

   
      //
      //
      //
      //
      //
         FastLen           = MathMax(FastLen,1);
         SlowLen           = MathMax(SlowLen,1);
         Length            = MathMax(Length,1);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
         
   IndicatorDigits(5);
   shortName = arrowsIdentifier+": "+timeFrameToString(timeFrame)+" Double T3 BB Macd ("+FastLen+","+SlowLen+","+Length+")";
   IndicatorShortName(shortName);
      SetIndexLabel(0, "Upperband");
      SetIndexLabel(1, "Lowerband");  
      SetIndexLabel(2, "BB Macd");
      SetIndexLabel(3, NULL);
      SetIndexLabel(4, NULL);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
      double alpha = 2.0 / (Length + 1.0);
      for(i = limit; i >= 0 ; i--)
      {
         double tmacd = iT3(iMA(NULL,0,1,0,MODE_SMA,FastT3Price,i),FastLen,FastT3Hot,FastT3Original,i,0)
                      - iT3(iMA(NULL,0,1,0,MODE_SMA,SlowT3Price,i),SlowLen,SlowT3Hot,SlowT3Original,i,1);
                      
         if (DoubleMacd)
               bbMacd[i] = iT3(tmacd,FastLen,FastT3Hot,FastT3Original,i,2) - iT3(tmacd,SlowLen,SlowT3Hot,SlowT3Original,i,3);
         else  bbMacd[i] = tmacd; 
         
         buffer6[i]  = buffer6[i+1] + alpha*(bbMacd[i] - buffer6[i+1]); 
         double sDev = iDeviation(bbMacd, buffer6[i], Length, i);  
         buffer1[i]  = buffer6[i] + (StDv * sDev);
         buffer2[i]  = buffer6[i] - (StDv * sDev);    
         buffer4[i]  = EMPTY_VALUE;  
         buffer5[i]  = EMPTY_VALUE; 
       
         //
         //        
         //
         //
         // 
         
         slope[i] = slope[i+1];
         trend[i] = trend[i+1];
         if (bbMacd[i] > bbMacd[i+1]) slope[i] =  1; 
         if (bbMacd[i] < bbMacd[i+1]) slope[i] = -1; 
         if (bbMacd[i] > buffer1[i])  trend[i] =  1; 
         if (bbMacd[i] < buffer2[i])  trend[i] = -1; 
            
         if (slope[i]==-1) if (drawDots)     buffer4[i] = bbMacd[i];
                           else  PlotPoint(i,buffer4,buffer5,bbMacd);
         manageArrow(i);   
      }
   manageLabels();
   manageAlerts();   
   return(0);
   }
       
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffer1[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,FastT3Hot,FastT3Original,FastT3Price,SlowLen,SlowT3Hot,SlowT3Original,SlowT3Price,Length,StDv,DoubleMacd,0,y);
         buffer2[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,FastT3Hot,FastT3Original,FastT3Price,SlowLen,SlowT3Hot,SlowT3Original,SlowT3Price,Length,StDv,DoubleMacd,1,y);
         bbMacd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,FastT3Hot,FastT3Original,FastT3Price,SlowLen,SlowT3Hot,SlowT3Original,SlowT3Price,Length,StDv,DoubleMacd,2,y);
         buffer4[i]= EMPTY_VALUE;
         buffer5[i]= EMPTY_VALUE;
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,FastT3Hot,FastT3Original,FastT3Price,SlowLen,SlowT3Hot,SlowT3Original,SlowT3Price,Length,StDv,DoubleMacd,6,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,FastT3Hot,FastT3Original,FastT3Price,SlowLen,SlowT3Hot,SlowT3Original,SlowT3Price,Length,StDv,DoubleMacd,7,y);
         
         if (drawDots && slope[i]==-1) buffer4[i] = bbMacd[i];   
         manageArrow(i);
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               buffer1[i+k] = buffer1[i] + (buffer1[i+n] - buffer1[i]) * k/n;
               buffer2[i+k] = buffer2[i] + (buffer2[i+n] - buffer2[i]) * k/n;
               bbMacd[i+k]  = bbMacd[i]  + (bbMacd[i+n]  - bbMacd[i])  * k/n;
               if (buffer4[i+k] != EMPTY_VALUE) buffer4[i+k] = bbMacd[i+k];
            }                  
   }
   if (!drawDots) for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,buffer4,buffer5,bbMacd);
   manageLabels();
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][24];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(double& array[],double dMA, int period,int shift)
{
   double dSum = 0.00;
   int    i;

   for(i=0; i<period; i++) dSum += (array[shift+i]-dMA)*(array[shift+i]-dMA);
   
   return(MathSqrt(dSum/period));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageLabels()
{
   if (calculateValue) return;

   int window = WindowFind(shortName);
   color theColor = LabelsColorNeutral;
      if (bbMacd[0]>buffer1[0]) theColor = LabelsColorUp;
      if (bbMacd[0]<buffer2[0]) theColor = LabelsColorDown;

   //
   //
   //
   //
   //
      
   string name = arrowsIdentifier+":"+"label_Lowerband";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance+28);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"Lower Band : " + DoubleToStr(buffer2[0],5), 10, "Arial Black", LabelsColorNeutral);

      name = arrowsIdentifier+":"+"label_BB Macd";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance+14);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"BB Macd : " + DoubleToStr(bbMacd[0],5), 10, "Arial Black", theColor);

      name = arrowsIdentifier+":"+"label_Upperband";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"Upper Band : " + DoubleToStr(buffer1[0],5), 10, "Arial Black", LabelsColorNeutral); 
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar,"sloping up");
         if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar,"sloping down");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnBandBreakout && trend[whichBar]!= trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar,"breaking upper band");
         if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar,"breaking lower band");
      }   
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BBMacd ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," BBMacd " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BBMacd "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow(i,arrowsOnSlopeUpColor,arrowsOnSlopeUpCode,arrowsOnSlopeUpSize,false);
         if (slope[i] ==-1) drawArrow(i,arrowsOnSlopeDnColor,arrowsOnSlopeDnCode,arrowsOnSlopeDnSize,true);
      }
      
      if (arrowsOnBandBreakout && trend[i]!= trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsOnBandBreakoutUpColor,arrowsOnBandBreakoutUpCode,arrowsOnBandBreakoutUpSize,false);
         if (trend[i] ==-1) drawArrow(i,arrowsOnBandBreakoutDnColor,arrowsOnBandBreakoutDnCode,arrowsOnBandBreakoutDnSize,true);
      }   
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize,bool up)
{
    string name = arrowsIdentifier+":"+Time[i];
    double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize ); 
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

